/*
 * TCP_Client.h
 *
 *  Created on: Mar 10, 2022
 *      Author: Small_Horse
 */

#ifndef USER_TCP_CLIENT_H_
#define USER_TCP_CLIENT_H_


#include "debug.h"
#include "WCHNET.h"
#include "string.h"

/* Fast Mode define */
#define FAST_FLASH_PROGRAM_START_ADDR    ((uint32_t) 0x08010000)
#define FAST_FLASH_CHECK_ADDR            ((uint32_t)(0x08010000 - 256))

#define FAST_FLASH_PROGRAM2_START_ADDR   ((uint32_t)0x08018000)
#define FAST_FLASH_PROGRAM_END_ADDR      ((uint32_t)0x08020000)
#define FAST_FLASH_PAGE_SIZE             (128)
#define FAST_FLASH_SIZE                  (128 * FAST_FLASH_PAGE_SIZE)

#define bin_bufsize (32768)
#define RECE_BUF_LEN                          WCHNET_TCP_MSS*2


typedef struct _bin_struct
{
    u8  buf[bin_bufsize];           //binļ
    u32 p_recv;             //
    u32 p_send;             //
    u32 remain_len;         //

}bin_struct;

extern u8 MACAddr[6];
extern u8 IPAddr[4];
extern u8 GWIPAddr[4];
extern u8 IPMask[4];
extern u8 DESIP[4];

bin_struct bin;                 //binļ
extern u8 socket_recv_cnt;                    //socketռ



extern void mStopIfError(u8 iError);
extern u8 WCHNET_LibInit(const u8 *ip,const u8 *gwip,const u8 *mask,const u8 *macaddr);
extern void SET_MCO(void);
extern void TIM2_Init( void );
extern void WCHNET_CreatTcpSocket(void);
extern void WCHNET_HandleSockInt(u8 sockeid,u8 initstat);
extern void WCHNET_HandleGlobalInt(void);
#endif /* USER_TCP_CLIENT_H_ */
