/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2021/06/06
* Description        : Main program body.
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* SPDX-License-Identifier: Apache-2.0
*******************************************************************************/

/*
 *@Note 
 ADCʹDMẠ
 ADCͨ2(PA2),ͨͨDMAȡ ADC1024תݡ
 
*/

#include "debug.h"
#include "TCP_Client.h"


//
bin_struct bin;                 //binļ

/* Global define */
typedef enum
{
    FAILED = 0,
    PASSED = !FAILED
} TestStatus;

/* Global Variable */
uint32_t              EraseCounter = 0x0, Address = 0x0;
uint16_t              Data = 0xAAAA;
uint32_t              WRPR_Value = 0xFFFFFFFF, ProtectedPages = 0x0;
uint32_t              NbrOfPage;
volatile FLASH_Status FLASHStatus = FLASH_COMPLETE;

volatile TestStatus MemoryProgramStatus = PASSED;
volatile TestStatus MemoryEraseStatus = PASSED;




//
void Writebin_to_Flash();           //BinļFLASH洢

/*********************************************************************
 * @fn      GPIO_Cfg_init
 *
 * @brief   PA0Ϊ
 *
 * @return  none
 */
void GPIO_Cfg_init(void)
{
    GPIO_InitTypeDef GPIO_InitStructure;

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
    GPIO_Init(GPIOA, &GPIO_InitStructure);
}

/*******************************************************************************
* Function Name  : Flash_Update_Bin
* Description    : FLASHBin
* Input          : None
* Output         : FAILEDʧ      PASSEDɹ
* Return         : None
*******************************************************************************/
u8 Flash_Update_Bin(void)
{
    u32 buf[32*256];
    u16 i;

    FLASH_Unlock_Fast();

    for(i=0; i<32*256; i++)
    {
        buf[i] = *(u32 *)(FAST_FLASH_PROGRAM2_START_ADDR + 4 * i);            //ȡAPP2
    }

    FLASH_EraseBlock_32K_Fast(FAST_FLASH_PROGRAM_START_ADDR);                   //APP1ݣǰ32KB

    for(i=0; i<128; i++)
    {
        FLASH_ProgramPage_Fast(FAST_FLASH_PROGRAM_START_ADDR + 256 * i, (u32 *)(&(buf[64*i])));     //дAPP1
    }
    for(i=0; i<32*256; i++)
    {
        if(buf[i] != *(u32 *)(FAST_FLASH_PROGRAM_START_ADDR + 4 * i))            //У
        {
            return   FAILED;
        }
    }

    FLASH_EraseBlock_32K_Fast(FAST_FLASH_PROGRAM2_START_ADDR);                  //APP2ݣǰ32KB
    FLASH_Lock_Fast();
    return   PASSED;
}

/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main(void)
{
    u32 bin_check = 0;
    u32 bin_flag = 0x57434820;      //'W','C','H',' '
    u16 i;

    Delay_Init();
    USART_Printf_Init(115200);
    printf("SystemClk:%d\r\n", SystemCoreClock);

    GPIO_Cfg_init();            //PA0--

    /************************************ ETHAPP  **********************************************/
    if(GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_0)==0)
    {
        Delay_Ms(10);
        if(GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_0)==0)
        {
            /**************************** ETHʼ  ****************************/
            SET_MCO();
            TIM2_Init();
            WCH_GetMac(MACAddr);                                                     /*ȡоƬMacַ*/
            i=WCHNET_LibInit(IPAddr,GWIPAddr,IPMask,MACAddr);                        /*̫ʼ*/
            mStopIfError(i);
            if(i==WCHNET_ERR_SUCCESS) printf("WCHNET_LibInit Success\r\n");
            while(!(WCHNET_GetPHYStatus()&PHY_LINK_SUCCESS))                         /*ȴPHYӳɹ*/
            {
                Delay_Ms(100);
            }
            WCHNET_CreatTcpSocket();                                                 /*Tcp socket*/
            while(1)
            {
                WCHNET_MainTask();
                if(WCHNET_QueryGlobalInt())                                            /*ѯ̫ȫжϣжϣȫжϴ*/
                {
                    WCHNET_HandleGlobalInt();
                }
                Writebin_to_Flash();            //յBinļFLASH洢
            }
        }
    }

    /************************************ APPݸ  **********************************************/
	bin_check = *(__IO uint32_t *)(FAST_FLASH_CHECK_ADDR);          //ȡУ
    if(bin_check == bin_flag) {
        printf("*** begin update ***\n");
        while(Flash_Update_Bin() != PASSED)         //FLASHBin
        {
            i++;
            printf("*** error update : %d ***\n", i);
            if(i >= 5)  break;
            Delay_Us(100);
        };

        if(i < 5)          //
        {
            printf("*** update success! ***\n");
            FLASH_Unlock_Fast();
            FLASH_ErasePage_Fast(FAST_FLASH_CHECK_ADDR);
            FLASH_Lock_Fast();
        }
    }

    NVIC_EnableIRQ(Software_IRQn);
    NVIC_SetPendingIRQ(Software_IRQn);
}


/*******************************************************************************
* Function Name  : Writebin_to_Flash
* Description    : BinļFLASH洢
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Writebin_to_Flash()
{
    u16 i;
    u32 len;            //ǰݳ
    u16 page;           //ҳ
    static u32 last_len = 0;        //ʷݳ
    static u16 last_page = 0;       //ʷҳ
    u32 bin_check;
    u32 bin_flag = 0x57434820;      //'W','C','H',' '


    if(socket_recv_cnt)            //
    {
        socket_recv_cnt--;
        len = bin.remain_len;
        if(len % 256)
            page = len/256 + 1;         //FLASHҳ
        else
            page = len/256;

        FLASH_Unlock_Fast();
        if(last_len % 256)              //ǰҳδ
        {
            last_page--;
            FLASH_ErasePage_Fast(FAST_FLASH_PROGRAM2_START_ADDR + 256*last_page);
        }

        for(i=last_page; i<page; i++)
        {
            FLASH_ProgramPage_Fast(FAST_FLASH_PROGRAM2_START_ADDR + 256 * i, (u32 *)(&(bin.buf[256*i])));     //дAPP2
        }


        bin_check = *(__IO uint32_t *)(FAST_FLASH_CHECK_ADDR);          //ȡУ
        if(bin_check != bin_flag) {
            FLASH_ErasePage_Fast(FAST_FLASH_CHECK_ADDR);
            FLASH_ProgramWord(FAST_FLASH_CHECK_ADDR, bin_flag);
        }

        FLASH_Lock_Fast();

        last_len = len;
        last_page = page;
        printf("Now Len: %d\r\n", (u16)len);
    }
}


